package
{
	import Utils.Generic;
	
	import World.World;
	
	import flash.xml.XMLNode;
	
	import org.flixel.*;
	
	public class LoadingState extends FlxState
	{
		private var txt:FlxText = null;
		private var city:FlxSprite = null;
		private var loaded:Boolean = false;
		[Embed(source='assets/imgs/intro/intro.png')] private var ImgIntro:Class;
		[Embed(source='assets/imgs/maps/street_2.png')] private var ImgCity:Class;		
		
		public function LoadingState()
		{
			super();
			
			city = new FlxSprite();
			city.loadGraphic(ImgCity);
			city.y = 3;
			this.add(city);

			var sp2:FlxSprite = new FlxSprite();
			sp2.loadGraphic(ImgIntro);
			sp2.blend ="multiply";
			this.add(sp2);
			
			txt = new FlxText(50, 85, FlxG.width, "loading config...")
			txt.setFormat(null,8,0x333333,"left")
			txt.alpha = 1;
			this.add(txt);
			
			//load config
			loadConfig(inner);
			function inner():void
			{
				loadWorld(gamejam.vars["world"],inner_world_loaded);
			}
			
			function inner_world_loaded():void
			{
				txt.text = "click to start...";
				loaded = true;
				//launchWorld();
			}
		}
		
		/* load file and launch */
		private function loadWorld(filename:String, on_complete:Function = null):void
		{
			txt.text = "loading world...";
			var w:World.World = new World.World();
			Utils.Generic.loadXMLFile( gamejam.ASSETS_ROOT + filename, inner,inner_error);
			
			//load world config
			function inner(url:String, xml:XMLNode):void
			{
				//loads maps config
				w.fromXML(xml);
				w.loadResources(on_complete);
			}
			
			function inner_error():void
			{
				trace("error...");
				txt.text = "error\nmissing file";
			}
		}
		
		override public function update():void
		{
			if(city)
				city.x -= 0.5;
			
			if(FlxG.mouse.justPressed() && loaded)
				launchWorld();
			
			super.update();
		}

		private function launchWorld():void
		{
			trace("launching world...");
			var play:PlayState = new PlayState();
			FlxG.switchState(play);
			//play.start();
		}
		
		public function loadConfig(on_load:Function = null):void
		{
			Utils.Generic.loadXMLFile( gamejam.ASSETS_ROOT + "config.xml", inner);
			
			function inner(url:String, xml:XMLNode):void
			{
				for each(var node:XMLNode in xml.childNodes)
				{
					if (node.localName == "var" && node.attributes.name && node.attributes.value)
					{
						gamejam.vars[node.attributes.name] = node.attributes.value;
					} 
				}
				txt.text = "loaded"
				if (on_load != null)
					on_load();
			}
		}	
	}
}