package Logic
{
	import flash.utils.getTimer;
	
	import org.flixel.FlxG;
	import org.flixel.FlxSprite;

	public class Controller
	{
		static public var controllers:Array = [];
		
		public var _type:String = "none";
		public var _target:FlxSprite = null;
		
		public function Controller(target:FlxSprite, type:String="none")
		{
			this._target = target;
			this._type = type;
			controllers.push(this);
		}
		
		static public function removeAll():void{
			controllers = [];
		} 
		
		static public function updateAll():void{
			for each (var c:Controller in controllers)
			{
				c.update();				
			}
		} 
		
		//Basic automatic controllers
		public function update():void
		{
			if (_target == null) return;
			
			switch(_type)
			{
				case "blink": _target.alpha = 0.5 + 0.3 * Math.sin(getTimer() * 0.001) + 0.1 * Math.random(); break;
				case "shake": _target.x += 2*Math.random()-1; _target.y += 2*Math.random()-1; break;
				case "fadeIn": _target.alpha = ( _target.alpha < 1 ? _target.alpha + 0.001 : 1); 
					break;
				case "fadeOut": _target.alpha = ( _target.alpha > 0 ? _target.alpha - 0.001 : 0); break;
			}
		}
	}
}