package
{
	import flash.display.*;
	import flash.events.*;
	import flash.utils.*;
	
	import org.flixel.FlxSprite;	
	import World.World;

	public class Pedestrian extends FlxSprite
	{
		public var speed:int = 20;
		
		public function Pedestrian(X:Number=0, Y:Number=0, SimpleGraphic:Class=null)
		{
			super(X, Y, SimpleGraphic); 
			
			loadType("anna",3 + Math.random() * 2);  
			y = World.inst.GROUND_HEIGHT;
			x = Math.random() * World.inst.current_street.length;
			facing = Math.random() > 0.5 ? RIGHT : LEFT;
			speed = 10 + 30 * Math.random();
		}
		
       override public function update():void
        {
        	velocity.x = (facing == RIGHT ? 1 : -1) * speed;
        	
        	//ground collision
        	var off:int = -this.height + this.offset.y;
            if (y - off > World.inst.GROUND_HEIGHT)
            {
            	y = World.inst.GROUND_HEIGHT + off;
            	velocity.y = 0;  
            	//play("normal");
            }
                    	
        	if (x > World.inst.current_street.length + 10)
        		x = -10;
        	if (x < -10)
        		x = World.inst.current_street.length + 10
        	else
        	play("run");
        	
        	 super.update();
        }
        
 		public function loadType(type:String, num:uint = 0):void
  		{
  			var o:Object = World.inst.getCharacterType(type);
  			if (o == null) return;
  			
  			var b:Bitmap = ResourcesLoader.getFile( o.images[num] );
  			if (b == null)
  			{
  				trace("ERROR CHARAC BITMAP NULL");
  				return;
  			} 
  			
  			loadExtGraphic(b, true, true, o.info[0], o.info[1]);
            width = o.info[2];
            height = o.info[3];
            offset.x = o.info[4];
            offset.y = o.info[5];
			for each ( var a:Object in o.anims )
				addAnimation(a.name, a.frames, a.fps );
  		}
	}
}