package
{
	import Utils.Generic;
	
	import flash.display.*;
	import flash.events.*;
	import flash.utils.*;
	
	import org.flixel.FlxG;
	import org.flixel.FlxSprite;
	import org.flixel.FlxText;
	import World.World;
	import World.Character;

	public class Person extends FlxSprite 
	{
		[Embed(source='assets/pixel_me_old.png')] private var ImgPlayer:Class;
		[Embed(source='assets/bla.png')] private var ImgBubble:Class;

		private var _move_speed:int = 400;
		private var _jump_power:int = 800;   

		public var _id:String = "";
		public var _street:String = "";
		public var block_anims:Boolean = false;
		public var block_input:Boolean = false;
		
		public var _text:FlxText = null;
		public var _bubble:FlxSprite = null;
		
		public var info_txt:Array = [];
		
		public var _name:String = "";
		public var _sex:String = "M";
		public var _shape:uint = 0;
		
		public var is_visible:Boolean = true;
		
		public var _last_serialize:String = "";
		
		public var last_building_x:int = -1;
		public var last_building_y:int = -1;
		public var ready:Boolean = false;
		
		static public var LAST_ID:int = 0;
        
        static public var PERSON_LOADED_EVENT:String = "person loaded event";
		
		public function Person(id:String = "")
		{
			super()
			
			_id = id;
			//updateShape();

			//Max speeds
            maxVelocity.x = World.inst.MAXVELX;
            maxVelocity.y = World.inst.MAXVELY;

            //Gravity
            //if (_is_player)
            	acceleration.y = World.inst.GRAVITY;            
            //Friction
            drag.x = 100;
			facing = RIGHT;
			
			
			
			/*
			_text = new FlxText(0,0,30,id.toString());
			_text.setFormat(null,8,_is_player ? 0xFFFFFF : 0x778ea1,"center",0x233e58);
			PlayState.instance.add(_text);
			*/            
  		}    
  		
  		public function loadType(type:String, num:uint = 0):void
  		{
  			var o:Object = World.inst.getCharacterType(type);
  			if (o == null) return;
  			
  			var b:Bitmap = ResourcesLoader.getFile( o.images[num] );
  			if (b == null)
  			{
  				trace("ERROR CHARAC BITMAP NULL");
  				return;
  			} 
  			
  			ready = true;
  			loadExtGraphic(b, true, true, o.info[0], o.info[1]);
            width = o.info[2];
            height = o.info[3];
            offset.x = o.info[4];
            offset.y = o.info[5];
			for each ( var a:Object in o.anims )
				addAnimation(a.name, a.frames, a.fps );
  		}
  		
  		public function show():void
  		{
  			if (is_visible == false)
  				World.coll_group.add(this);
  			is_visible = true;
  		}
  		
  		public function hide():void
  		{
  			if (is_visible)
	  			World.coll_group.remove(this);
	  		is_visible = false;
  		}

		public function loadDefault():void
		{
			loadGraphic(ImgPlayer, true, true, 32, 32);

            //bounding box tweaks
            width = 16;
            height = 32;
            offset.x = 8;
            offset.y = 0;
            
			addAnimation("normal", [0], 0);
			addAnimation("run", [1,3,2,3], 10);
			addAnimation("jump", [1], 0);
			addAnimation("dance", [0,3], 10);
			ready = true;
		}
		
		public function loadFromServer(filename:String, on_ready:Function = null):void
		{
			Utils.Generic.loadTextFile(filename, inner);
			var that:Person = this;
			
			function inner(url:String, data:String):void
			{
				var img_file:String = "";
				
				var lines:Array = data.split("\n");
				var img_filename:String = lines[0];
				img_filename = Utils.Generic.trim(img_filename);
				info_txt = lines;
				
				Utils.Generic.loadBitmapFile(img_filename, inner_load);
			
				function inner_load(url:String, data:*):void
				{
					var sizes:Array = info_txt[1].split(",");
					loadExtGraphic(data,true,true, parseInt(sizes[0]), parseInt(sizes[1]));
		            width = parseInt(sizes[2]);
		            height = parseInt(sizes[3]);
		            offset.x = parseInt(sizes[4]);
		            offset.y = parseInt(sizes[5]); 
					
					for (var i:uint = 2; i < info_txt.length;i++)
					{
						var a:Array = info_txt[i].split(":");
						var name:String = a[0];
						var fps:uint = parseInt(a[1]);
						var frames:Array = a[2].split(",");
						for (var j:uint = 0; j < frames.length; j++)
							frames[j] = parseInt(frames[j]);
						addAnimation(name,frames,fps,true);
					}
					ready = true;
					if (on_ready != null)
						on_ready(that);
				}
			}
		}
		
		//Serialization
		
		public function unserialize(str:String):void
		{
			if (str == "") return;
			
			var a:Array = str.split('|');			
			a.shift(); //msg type
			a.shift(); //id
			_street = a.shift();
			x = int(a.shift());
			y = int(a.shift());
			facing = a.shift() == 'r' ? RIGHT : LEFT;
			velocity.x = a.shift();
			velocity.y = a.shift();
			play(a.shift());
			
			if (x == -100 && y == -100)
				World.inst.deletePerson(_id);
		}
		
		public function serialize():String
		{
			var s:String = "";
			s += _street;
			s += "|" + x.toFixed(3) + "|" + y.toFixed(3);
			s += "|" + ( this.facing == LEFT ? 'l' : 'r' );
			s += "|" + velocity.x.toFixed(3) + "|" + velocity.y.toFixed(3);
			//s += " " + acceleration.x.toFixed(3) + " " + acceleration.y.toFixed(3);
			if (_curAnim)
				s += "|" + _curAnim.name;
			else
				s += "|normal";
			
			
			_last_serialize = s;
			return s;
		}		

		/*
		public function unserialize(str:String):void
		{
			trace("unserializing " + _id.toString() + " -> " + str);
			if (str == "")
				return;
			var a:Array = str.split(' ');
			if (a.length > 5)
			{
				//_id = a.shift();
				a.shift(); //id
				a.shift(); //msg_type
				x = int(a.shift());
				y = int(a.shift());
				velocity.x = a.shift();
				velocity.y = a.shift();
				acceleration.x = a.shift();
				acceleration.y = a.shift();
				facing = a.shift() == 'R' ? RIGHT : LEFT;
				play(a.shift());
			}
		}
		
		public function serialize():String
		{
			var s:String = "";
			s += x.toFixed(3) + " " + y.toFixed(3);
			s += " " + velocity.x.toFixed(3) + " " + velocity.y.toFixed(3);
			s += " " + acceleration.x.toFixed(3) + " " + acceleration.y.toFixed(3);
			s += " " + ( this.facing == LEFT ? 'L' : 'R' );
			s += " " + _curAnim.name;
			return s;
		}
		*/
		
		public function isPlayer():Boolean
		{
			return World.inst._player == this;
		}
		
		public function isDistToCrossing(dist:uint):Boolean
		{
			var v:Number = (x % World.inst.building_width);
			if ( v < dist || v > World.inst.building_width - dist)
				return true; 
			return false;
		}
		
		public function createPersonality():void
		{
			_sex = Math.random() > 0.5 ? "M" : "F";
			var names:Array = gamejam.vars[ _sex == "M" ? "man_names" : "woman_names" ].split(","); 
			var pos:int = names.length * Math.random();
			_name = names[ pos ];
			_shape = _sex == "M" ? 0 : 2;
			loadType("anna",_shape);
		}
		
		//Collisions and keyboard *************************
		public function enterStreet(front:Boolean = true):void
		{
			if ( isDistToCrossing(World.inst.crossing_width*0.5) == false )
				return;
				
			var o:Object = World.inst.current_street.getCrossing(x);
			if (o == null) return;
			
			play( front ? "front" : "back");
			block_input = true;
			block_anims = true;
			velocity.x = 0;
			
			var i:String = o.dest_street;
			World.inst.changeStreet(i, parseInt(o.dest_x),true,inner);
			
			function inner():void
			{
				block_input = false;		
				block_anims = false;
				velocity.x = 0;
				x = World.inst.entering_x;
				_street = World.inst.current_street._id;
			}
		}
		
		public function saySomething(v:String):void
		{
			play("talk"); 
			if (_text == null)
				_text = new FlxText(0,0,100);
			_text.text = v;
			if (_bubble == null)
			{
				_bubble = new FlxSprite();
				_bubble.loadGraphic(ImgBubble);
				World.ST.add(_bubble);
			}
		}
		
		public function checkSoundThreshold():void
		{   
			if (StreetSongs.instance == null) return;
			
			var building_x:int = parseInt( World.inst.current_street._id );
			
			if ( parseInt(World.inst.current_street._id) % 2 == 0)
				building_x /= 2;
			else	
				building_x = (building_x - 1) / 2;
			
			var building_y:int = Math.floor(x / World.inst.building_width);
			
			//PlayState.instance._text.text = building_x.toString() + "," + building_y.toString();
			
			if (last_building_x != building_x || last_building_y != building_y)			
				StreetSongs.instance.transState(building_y,building_x);
				
			last_building_x = building_x;
			last_building_y = building_y;
		}

		
        override public function update():void
        {
        	//other street
        	
        	//*
        	if (World.inst.current_street == null && World.inst.current_street._id != _id)
        		hide();
        	else
        		show();
        	//*/
        	
        	//ground collision
        	var off:int = -this.height + this.offset.y;
            if (y - off > (World.inst.GROUND_HEIGHT + (isDistToCrossing(World.inst.road_width*0.5) ? 2 : 0)))
            {
            	y = World.inst.GROUND_HEIGHT + (isDistToCrossing(World.inst.road_width*0.5) ? 2 : 0) + off;
            	velocity.y = 0;  
            	//play("normal");
            }
            
            //street ends
            if (x < 10)
            {	
            	x = 10;
            	velocity.x = 0;
            }
            if (World.inst.current_street && x > World.inst.current_street.length - 10)
            {
            	x = World.inst.current_street.length - 10;
            	velocity.x = 0;
            }
            
            //sound threshold
            if (isPlayer())
	            checkSoundThreshold();
                    	
        	//trace(y);
        	if (isPlayer() && !block_input)
        	{
	            if (FlxG.keys.UP)
	            	enterStreet(false);
	            else if (FlxG.keys.DOWN)
	            	enterStreet(true);

	            if (FlxG.keys.LEFT)
				{
					facing = LEFT;
					velocity.x -= _move_speed * FlxG.elapsed;
				}
				else if (FlxG.keys.RIGHT)
				{
					facing = RIGHT;
					velocity.x += _move_speed * FlxG.elapsed;
				}
				
				//jumping
				if (FlxG.keys.justPressed("SPACE") && y > World.inst.GROUND_HEIGHT - 50)
				{
					velocity.y = -World.inst.JUMP_POWER;
				}	
							
				if (FlxG.keys.justPressed("T") )
					block_anims = !block_anims;
				if (FlxG.keys.justPressed("Y") )
					saySomething("ha");
				
        	}
	
			if (block_anims==false)
			{
				if (velocity.x == 0 && velocity.y == 0)
					play("normal");
				else 
				{ 
					if (velocity.y == 0)
						play("run");
					else
						play("jump");
				}
			}
			
			if (isPlayer())
				Server.inst.send("1|" + _id + "|" + serialize() );
        	
        	/*
        	if (_last_serialize != '')
        	{
        		unserialize( _last_serialize );
        		_last_serialize = '';
        	}
        	*/

			
			//if (y > 100) y = 100;
            //min height

            super.update();
            
            if (_bubble)
            {
            	_bubble.x = x + 3;
            	_bubble.y = y - 10;
            }          

            
            /*
        	_text.text = _id.toString();
        	_text.x = this.x - 8;
        	_text.y = this.y - 12;            
            //trace( _id.toString() + " " + x.toString() + "," + y.toString() );
            */
        }
	}
}