package
{
	import flash.xml.*;
	
	import org.flixel.*;
	import World.World;
		
	public class Street 
	{
		public var _id:String = "";
		
		public var buildings:Array = [];
		public var crossing:Array = [];
		public var blocks:Array = [];
		public var sprites:Array = [];
		public var length:uint = 0;
		public var server_length:uint = 0;
		
        //public var _bg_tiles:FlxTilemap = null;	

        //[Embed(source = 'assets/background_city.png')] private var ImgTiles:Class;	
		
		public function Street()
		{
			//createRandom();
		}
		
		public function createRandom():void
		{
			/*
			_bg_tiles = new FlxTilemap();
			_bg_tiles.loadMap("0101010101010", ImgTiles, 32)
            _bg_tiles.drawIndex = 1;
            //_bg_tiles.collideIndex = 1;
            */  
            //buildings = ["house","house2","church","office","office2","park","hotel"];
            buildings = ["house2","house2","house2","office","office2","park","hotel"];
            create();
            //show();
		}
		
		
		public function create():void
		{
			var pos:uint = 0;
			for each(var v:Object in buildings)
			{
				var building:FlxSprite = new FlxSprite(pos);
				var o:Object = World.inst.getBuildingType(v.type);
				building.loadExtGraphic(o.bitmap,false,false, o.bitmap.bitmapData.width, o.bitmap.bitmapData.height);			
				pos += o.bitmap.bitmapData.width;
				sprites.push(building);
			}
			length = pos;
		}
		
		public function show():void
		{
			trace("showing...");
			
			if(sprites.length == 0)
				create();
			
			for each(var b:FlxSprite in sprites)
				World.bg_group.add(b);
				
			FlxG.fade.stop();	
            //FlxG.fade.start(0x00000000, 1);
		}
		
		public function hide(on_fade:Function = null):void
		{
			trace("hiding...");
			
            FlxG.fade.start(0xff000000, 0.5, inner);
            //inner();
            
			function inner():void
			{
				FlxG.fade.stop();	

				for each(var b:FlxSprite in sprites)
					World.bg_group.remove(b);
					
				if (on_fade != null)
					on_fade();
			}            
		}
		
		public function getDistanceToCrossing(x:int):int
		{
			var d:int = x % World.inst.building_width;
			if (d > World.inst.building_width * 0.5)
				d = World.inst.building_width - d;
			return d;  
		}
		
		public function getCrossing(x:int):Object
		{
			var i:Number = Math.round(x / Number(World.inst.building_width)) - 1;
			if (i < 0 || i >= crossing.length) return null;
			var o:Object = crossing[i];
			return o;
		}
		
		public function configureFromXML(xml:XMLNode):void
		{
			if (xml.attributes.id != null)
				_id = xml.attributes.id;
				
			if (xml.attributes.length != null)
				server_length = parseInt(xml.attributes.length);
			
			for each( var node:XMLNode in xml.childNodes)
			{
				if (node.localName == "building")
					buildings.push(node.attributes);
				else if (node.localName == "crossing")
					crossing.push(node.attributes);
				else if (node.localName == "block")
					blocks.push(node.attributes);
			}
		}

	}
}