package
{
	import Utils.*;
	
	import flash.display.*;
	import flash.events.*;
	import flash.utils.*;
	import flash.xml.*;
	
	import org.flixel.*;
	import World.World;
	import World.Character;
	import World.Street;
		
	public class World extends EventDispatcher
	{
		//the worls needs to have a map
		public static var inst:World = null;
		
		public var _player:Character = null;
		public var _people:Array = [];
		public var _people_by_id:Object = {};
		public var _pedestrians:Array = [];

		public var _session_id:String = "";
		
		public static var coll_group:FlxGroup = null; //colliding sprites
		public static var bg_group:FlxGroup = null; //bg sprites
        public  var _map:FlxTilemap;
        
        //landscape
        public var sky_img:Bitmap = null;
        public var city_img:Bitmap = null;
 		public var building_types:Object = {};
 		public var building_width:uint = 500;
 		public var building_height:uint = 0;
 		public var crossing_width:uint = 60;
 		public var road_width:uint = 40;
 		
 		public var current_street:Street = null;
 		public var streets:Array = [];
 		public var streets_by_id:Object = {};
 		public var entering_x:int = 0;
 		
 		public var mode:String = "init";
 		
 		public var sounds:StreetSongs = null;
 		
 		//characters
 		public var character_types:Array = [];
 		
        [Embed(source = 'assets/blocks.png')] private var ImgBit:Class;

        //public static var lyrStage:FlxGroup;
		
		static public var ST:FlxState = null;
		
		//params and vars
		public var GRAVITY:int = 400;
		public var MAXVELX:uint = 50;
		public var MAXVELY:uint = 100;
		public var GROUND_HEIGHT:int = 93;
		public var JUMP_POWER:uint = 200;
		
		public function World(state:FlxState)
		{
			inst = this;	
			ST = state;
		}
		
		public function init():void 
		{
			bg_group = new FlxGroup();
			ST.add(bg_group);
			
			coll_group = new FlxGroup();
			ST.add(coll_group);		
			
  			_player = new Character();
			
            processBuildings(inner);
            function inner():void
           	{
            	processCharacters(onAssetsLoaded);
            }
		}
		
		private function onAssetsLoaded():void
		{
            createBackground();
            //createObjects();
                      
            createCity();
            showText("Connecting...");
            //sounds = new StreetSongs();
  		}
  		
  		public function showText(str:String):void
  		{
  			PlayState.instance._text.text = str;
  		}
  		
  		private function onCityLoaded():void
  		{
            changeStreet("0",100);

        	showText("you are alone...");
        	Server.inst.on_error = alone;

  			if (0) //offline
  			{
				alone();
  			}
  			else
	  			Server.inst.connectToServer();
			
            addPedestrians();
            
            function alone():void
            {
				_player = new Character();
				_player.loadType("anna",1); 
				_player.x = 120;
				_player.y = 50;
				addPerson(_player); 
	        	showText("forever alone...");
            }

			//_room = new Room;			
			
			/*
			var p:Person = new Person();
			p.loadType("anna",1); 
			p.x = 120;
			p.y = 50;
			addPerson(p);
			
			/*
			p = new Person();
			p.loadType("anna",1); 
			p.x = 150;
			p.y = 50;
			addPerson(p);
			
			p = new Person();
			p.loadType("anna",2); 
			p.x = 180;
			p.y = 50;
			addPerson(p);

			_player = _people.shift();
			*/
			
			
			if (sounds)
				sounds.transState(0,0);

			//_player.loadDefault();
			//World.inst.addPerson(_player);			
			//_player.loadFromServer(gamejam.ASSETS_ROOT + "player_config.txt", inner);
			
			/*
			function inner(p:Person):void 
			{
				addPerson(p);
				p.x = 100;
				p.y = 50;
			}
			*/
		}
		
		public function createBackground():void
		{
			
			//sky lanscape
			var bg:FlxSprite = new FlxSprite();
			//bg.loadGraphic(ImgSky);
			bg.loadExtGraphic(getBuildingType("sky").bitmap,false,false,building_width,building_height);
			bg.scrollFactor = new FlxPoint(0,0); 
			//bg.x = bg.frameWidth * 0.5;
			//bg.y = bg.frameHeight * 0.5;
			bg_group.add(bg);
			
			//parallax
			bg = new FlxSprite();
			//bg.loadGraphic(ImgSky);
			bg.loadExtGraphic(getBuildingType("city").bitmap,false,false,building_width,building_height);
			//bg.y = -250;
			bg.scrollFactor = new FlxPoint(0.2,0); 
			//bg.x = bg.frameWidth * 0.5;
			//bg.y = bg.frameHeight * 0.5;
			bg_group.add(bg);
			//*/
			
			/*
			var b:FlxSprite = new FlxSprite();
			b.loadExtGraphic( ResourcesLoader.getFile("assets/pixel_man_2.png") );
			bg_group.add(b);
			//*/
		}
		
		public function createObjects():void
		{			
			//ground img
			var ground:FlxSprite = new FlxSprite(0,GROUND_HEIGHT);
			ground.createGraphic(1000,20,0xFF0000);
			coll_group.add(ground);

			var obj:FlxSprite = new FlxSprite(100,20);
			obj.createGraphic(1500,1500,0xFF00FF);
			bg_group.add(obj);
		}
		
		public function addPedestrians():void
		{
			var NUM_PEDESTRIANS:uint = parseInt(gamejam.vars["pedestrians"]);
			for (var i:int = 0; i < NUM_PEDESTRIANS; i++)
			{
				var p:Pedestrian = new Pedestrian();
				bg_group.add(p);
				_pedestrians.push(p);
			}
			
			var t:Timer = new Timer(30*1000,NUM_PEDESTRIANS+1);
			t.addEventListener(TimerEvent.TIMER, killPedestrian);	
			t.start();		
		}	
		
		private function killPedestrian(e:Event):void
		{
			if (_pedestrians.length == 0) {
				showText("now we are EXTINCT");
				return;
			}
			else if (_pedestrians.length < 10) {
				showText("we are the last ones...");
			}
			
			trace("pedestrian killed");
			var p:Pedestrian = _pedestrians.pop();
			bg_group.remove(p);
		}
		
		public function createCity(on_complete:Function = null):void
		{
			Utils.Generic.loadXMLFile(gamejam.ASSETS_ROOT + gamejam.vars["map"], inner);
			
			function inner(url:String, xml:XMLNode):void
			{
				processXML(xml);
				if (on_complete != null)
					on_complete();
			}
		}
		
		public function loadFromXML(txt:String):void
		{
			var xml:XMLNode = Utils.Generic.getXMLRoot(txt);
			if (xml != null)
				processXML(xml);
			else
				trace("CITY XML error");
		}
		
		public function processXML(xml:XMLNode):void
		{
			for each(var node:XMLNode in xml.childNodes)
			{
				if (node.localName != "street")
					continue;
					
				var street:Street = new Street();
				street.configureFromXML(node);
				addStreet(street);
			}
			
			trace("num streets:",streets.length);
			onCityLoaded();
		}
		
		//************************
		
		//collide sprites with map
		public function updateCollisions():void
		{
			if (_map)
			for each (var p:FlxSprite in coll_group.members) 
            	_map.collide(p);
		}
		
		//update camera pos
		public function updateCamera():void
		{
			if (_player)
				FlxG.follow(_player,0.01);
            FlxG.followAdjust(1.1, 1.1);
            if (current_street)
	            FlxG.followBounds(0,0,current_street.length,100);
            
            if (_map)
	            _map.follow();
            //FlxG.follow(_player,10);
            //FlxG.followAdjust(10, 10);
            //FlxG.followBounds(1,1,300,300);
   		}
   		
   		//loaders ****************
   		
   		public function loadSprite(url:String, w:uint, h:uint, x:Number, y:Number, collide:Boolean = false, on_load:Function = null):void
   		{
 			var s:FlxSprite = new FlxSprite(10,10);
			Utils.Generic.loadBitmapFile(url,inner);
			function inner(url:String, b:Bitmap):void
			{
				s.loadExtGraphic(b,true,true,w,h);
				s.x = x;
				s.y = y;
				if (collide)
					coll_group.add(s);
				else
					bg_group.add(s);
				
				if (on_load != null)
					on_load(s);
			}	
   		}
   		
  		public function processBuildings(on_complete:Function = null):void
  		{
            trace("processing buildings...");
  			var a:Array = gamejam.config["city"];
  			
  			var res:ResourcesLoader = new ResourcesLoader();
  			
  			for (var i:uint = 0; i < a.length; i++)
  			{
  				var l:Array = Utils.Generic.trim(a[i]).split(":");
  				if (l.length < 2) continue;
  				res.enqueueResource( gamejam.ASSETS_ROOT + l[1] );
  				addBuildingType(l[0], gamejam.ASSETS_ROOT + l[1]);
  			}
  			
  			res.loadResources(inner_load);
  			
  			function inner_load():void
  			{
  				for each(var o:Object in building_types)
  				{
  					o.bitmap = ResourcesLoader.getFile(o.filename);
  					if (o.bitmap == null)
  						trace("ERROR BITMAP NULL");
  				}
  				
  				trace("[OK] buildings loaded");
  				if (on_complete != null)
  					on_complete();
  			}    			
  		} 
  		
  		public function processCharacters(on_complete:Function):void
  		{
            trace("processing buildings...");
  			var a:Array = gamejam.config["characters"];
  			
   			var res:ResourcesLoader = new ResourcesLoader();

			var character:Object = {images:[], anims:[]};
  			for (var i:uint = 0; i < a.length; i++)
  			{
  				var l:String = Utils.Generic.trim(a[i]);
  				var d:Array = l.split(":");
  				
  				if (d.length < 2)
  				{
  					character_types.push(character);
  					character = {images:[], anims:[]};
  					continue;	
  				}
  				
  				if (d[0] == "name")
  					character.name = d[1];
  				else if (d[0] == "author")
  					character.author = d[1];
  				else if (d[0] == "info")
  					character.info = Utils.Generic.parseIntArray(d[1].split(","));
  				else if (d[0] == "image")
  				{	
  					var images:Array = d[1].split(",");
  					for each(var im:String in images)
  					{
  						res.enqueueResource( gamejam.ASSETS_ROOT + im );
  						character.images.push( gamejam.ASSETS_ROOT + im );
  					}
  				}
  				else if (d[0] == "anim")
  				{
  					trace("Anim:",d[1]);
  					var anim:Object = { name:d[1], fps: parseInt(d[2]), frames: Utils.Generic.parseIntArray(d[3].split(",")) };
  					character.anims.push(anim);
  				}
  			}
  			
   			character_types.push(character);
 			
  			res.loadResources(inner_load);
  			
  			function inner_load():void
  			{
   				trace("[OK] characters loaded");
  				if (on_complete != null)
  					on_complete(); 				
  			}
  		}
  		
  		public function getCharacterType(type:String):Object
  		{
  			for each (var c:Object in character_types)
  				if (c.name == type)
  					return c;
  			return null;
  		}
  		
  		public function addBuildingType(name:String, filename:String, bitmap:Bitmap = null):void
  		{
  			var o:Object = {name:name, filename:filename, bitmap:bitmap};
  			building_types[name] = o;
  		}
  		
  		public function getBuildingType(name:String):Object
  		{
  			return building_types[name];
  		}
   		
   		public function addStreet(street:Street):void
		{
			streets[street._id] = street;
		}   		
		
		public function getStreet(id:uint):Street
		{
			return streets[id];
		}
		
		public function changeStreet(id:String, x:int, fade:Boolean = true, on_complete:Function = null):void
		{ 
			var new_street:Street = getStreet(parseInt(id));
			if (new_street == null) return;

			if (current_street)
				current_street.hide(fade ? inner : null );
			
			if (current_street == null || fade == false)
				inner();
			
			function inner():void
			{
				World.inst.current_street = new_street;
				World.inst.current_street.show();
				entering_x = x;	
				if (entering_x > World.inst.current_street.length)
					entering_x = World.inst.current_street.length;
				if (on_complete != null)
					on_complete();
			}
		}		
   		
   		//PERSONS *******************
   		public function getOrCreatePerson(id:String):Character
   		{
   			var p:Character = getPerson(id);
   			if (p==null)
   			{
   				trace("new person added:",id);
   				p = new Character(id);
   				p.loadType("anna",2);
				addPerson(p);
   			}
   			
   			return p;
   		}
   		
   		public function getPerson(id:String):Character
   		{
   			return _people_by_id[id];
   		}
		
		public function addPerson(p:Character):void
		{
			if (p == null) return;
            p.y = GROUND_HEIGHT;
  			coll_group.add(p);
  			_people.push(p);
  			_people_by_id[p._id] = p;
		}
		
        public function deletePerson(id:String):void
        {
         	trace("deleting player " + id );
  			var p:Character = getPerson(id);
  			if (p == null) return;
  			
  			_people.slice( _people.indexOf(p), 1);
  			_people_by_id[id] = null;
  			coll_group.remove(p);        	
        }
        
        public function updatePerson(id:String,str:String = ''):void
        {
         	trace("updating player " + id + " " + str );
  			var p:Character = getPerson(id);
  			if (p)
  				p._last_serialize = str;
  				//p.unserialize(str);
        }
        
        // ************* SERVER ************
        
        public function initFromServer(data:String):void
        {
        	var a:Array = data.split("|");
        	_session_id = a[0];
        	changeStreet(a[2],parseFloat(a[3]),false);
        	_player._id = _session_id;
        	_player._street = World.inst.current_street._id;
        	_player.x = parseFloat(a[3]);
        	addPerson(_player);
        	PlayState.instance._text.text = "find me...";
        }
        
        public function onNewPlayer(p:Character):void
        {
        	
        }
        
        public function onPlayerLeaves(p:Character):void
        {
        }
        
        public function onDisconnected():void
        {
			showText("Alone...");
        }
        
        //************ ON COLLISIONS
        
        /*
        //something steps on something
        public function stepping(a:FlxObject, b:FlxObject):void
        {
        	a.velocity.y = 0;
        }	
        */		

	}
}