package
{
	import Logic.CharacterController;
	
	import World.Character;
	import World.Map;
	import World.World;
	
	import flash.display.*;
	import flash.events.*;
	import flash.text.*;
	import flash.utils.*;
	
	import org.flixel.*;
	
	public class PlayState extends FlxState
	{
		//public var _player:Person = null;
		[Embed(source='assets/imgs/intro/hod.png')] private var ImgHud:Class;
		
         public static var t:Timer = null;
        
		 //screen
        protected var _fps:FlxText;
        public var _text:FlxText;
		public var _text_clear_time:Number = 0;
        protected var _inputtext:TextField;
        
        static public var _inst:PlayState = null;
		public var _world:World = null;   
		public var _is_input_text:Boolean = false;
		
		public var _lonebar:FlxSprite = null;
		public var _suppliesbar:FlxSprite = null;
		public var _last_bars_update:Number = 0;
		
		public function PlayState() 
		{
			_inst = this;
			this._world = World.World._inst;
			//FlxG.mouse.show();
						
			//connectToServer();
			//FlxG.pause = false;
			
			//gamejam.inst.loadConfig(initWorld);
		}
		
		public override function create():void
		{
			initWorld();
			
			var hud:FlxSprite = new FlxSprite();
			hud.loadGraphic(ImgHud);
			hud.scrollFactor.x = 0;
			hud.x = 2;
			hud.y = 1;
			hud.alpha = 0.8;
			//hud.blend = "add";
						
			_text = new FlxText(0,10,160,"").setFormat(null,8,0x778ea1,"left",0x233e58);
			_text.scrollFactor.x = _text.scrollFactor.y = 0;
			add(_text);	    	 	
			
			this.add(hud);
		}
		
		public function initWorld():void
		{
			//FlxG.visualDebug = true;
			_world.init(this);
			debugHud();

			var map:Map = World.World.getMap(World.World.start_map);
			if (map)
				map.switchTo(inner);
			else
				trace("Map not found... " + World.World.start_map);
			
			function inner():void
			{
				//map loaded
				var c:Character = null;

				c = spawnPerson("stranger","start");
				c._controller._behaviour = "stalker";
				c.x = map._bounds[2] * Math.random();
				c._controller._scared_of_yells = true; 
				c.teleportTo("cave",0,0,"table");
				
				c = spawnPerson("stranger","start");
				c._controller._behaviour = "follower";
				c.x = map._bounds[2] * Math.random();
				c._controller._scared_of_yells = true; 
				c.teleportTo("room",0,0,"table");
				
				for(var i:uint = 0; i < 3; i++)
				{
					c = spawnPerson("dog","start");
					c._controller._behaviour = "follower";
					c._controller._scared_of_light = true;
					c.teleportTo("ciutadella",0,0,"start");
					
					c.x = map._bounds[2] * Math.random();
					c.facing = Math.random() > 0.5 ? FlxObject.RIGHT : FlxObject.LEFT;
				}
				
				c = spawnPerson("explorer","home",true);
				c._info["loneliness"] = 1.0;
				c._info["supplies"] = 0.5;
			}
			
			//var server:Server = new Server();
		}
		
		public function spawnPerson(character_type:String, spawn_name:String, is_player:Boolean = false):Character
		{
			var p:Object = World.World._map.getEntity(spawn_name);
			
			var c:Character = new Character(p ? p.pos[0] : 0, p ? p.pos[1] : 0);
			World.World.addPerson(c);
			c.configure(character_type);
			World.World._main_group.add(c);
			c._in_map = World.World._map;
			
			var controller:CharacterController = new CharacterController();
			controller.setCharacter(c);			

			if(is_player)
				World.World._player = c;
			
			return c;
		}

        override public function update():void
        {
        	//if (_player == null)     		return;
			//FlxU.overlap(people, rooms, stepping );
			_world.update()
            super.update();
			//_world.updateCamera();
			
			if( getTimer() > _text_clear_time && _text )
				_text.text = "";
			
			if(getTimer() - _last_bars_update > 1000 && World.World._player._info["loneliness"] != null)
				updateBars();
			
			//FlxG.camera.x = Math.sin(gamejam.frames) * 100;
			
			gamejam.frames += 1;

			if(World.World._player)
			{
				World.World._focus.x = World.World._player.x;
				World.World._focus.y = World.World._player.y;
			}
			
			if (FlxG.keys.justPressed('H') )
			{
				World.World._coll_group.visible = !World.World._coll_group.visible;
			}

			//if (FlxG.keys.justPressed('ENTER') )
			//	setInputText( !_is_input_text );
			if (_fps)
				_fps.text = FlxU.floor(1/FlxG.elapsed)+" fps";
        }
		
		static public function showMsg(text:String, time:Number):void
		{
			_inst._text.text = text;
			_inst._text_clear_time = getTimer() + time * 1000;
		}

		public function updateBars():void
		{
			var loneliness:Number = World.World._player._info["loneliness"];
			var supplies:Number = World.World._player._info["supplies"];

			if(loneliness < 0) loneliness = 0;
			if(loneliness > 1) loneliness = 1;
			if(supplies < 0) supplies = 0;
			if(supplies > 1) supplies = 1;
			
			loneliness = 1 - loneliness;
			
			if(_lonebar)
				this.remove(_lonebar);
			
			if(loneliness > 0)
			{
				_lonebar = new FlxSprite();
				_lonebar.makeGraphic(1 + loneliness * 46,5,0xeeaa5522);
				_lonebar.x = 46;
				_lonebar.y = 3;
				_lonebar.scrollFactor.x = 0;
				this.add(_lonebar);
			}
			
			if(_suppliesbar)
				this.remove(_suppliesbar);
			
			if(supplies > 0)
			{
				_suppliesbar = new FlxSprite();
				_suppliesbar.makeGraphic(1 + supplies * 46,5,0xee55aa22);
				_suppliesbar.x = 143;
				_suppliesbar.y = 3;
				_suppliesbar.scrollFactor.x = 0;
				this.add(_suppliesbar);
			}
			
			_last_bars_update = getTimer();
		}
		
		
		
        /*
        //something steps on something
        public function stepping(a:FlxObject, b:FlxObject):void
        {
        	a.velocity.y = 0;        	        	
        }
        */
		
		public function debugHud():void
		{
			//_fps = new FlxText(FlxG.width-40,0,40).setFormat(null,8,0x778ea1,"right",0x233e58);
			//_fps.scrollFactor.x = _fps.scrollFactor.y = 0;
			//add(_fps);
			
			/*
			var f:TextFormat = new TextFormat("system",14,0xffffff);
			_inputtext = new TextField();
			_inputtext.embedFonts = true;
			_inputtext.defaultTextFormat = f;
			_inputtext.y = 20;
			_inputtext.height = 50;
			_inputtext.height = 20;
			_inputtext.type = TextFieldType.INPUT;
			addChild(_inputtext);
			_inputtext.text = ">";
			_inputtext.visible = false;
			//_inputtext.scaleX = _inputtext.scaleY = 1;
			*/
			
			/*
			var s:Sprite =new Sprite();
			with(s.graphics)
			{
				beginFill(0xff0000);
				drawCircle(0,0,100);
			}
			*/
			//addChild(s);
			//*/
		}
		
		public function setInputText(v:Boolean):void
		{
			_inputtext.visible = v;
			if (v)
			{
				gamejam.inst.stage.focus = _inputtext;
				_inputtext.text = "";
			}
			else
			{
				gamejam.inst.stage.focus = gamejam.inst;
			}
			_is_input_text = v;
		}
		
		/*
		public function connectToServer(e:Event=null):void
		{
			trace("waiting...");		
			server = new Server();
			server.addEventListener( Server.CONNECTED_TO_SERVER, onServerEvent );
			server.addEventListener( Server.SERVER_MSG, onServerEvent );
			server.addEventListener( Server.CONNECTION_ERROR, function(e:Event):void{ start(0); } );
			//server.connect('localhost',50000);
			server.connect('193.145.50.209',50000);
			
			t = new Timer(200);
			t.addEventListener( TimerEvent.TIMER, sendPlayerStatus );
			t.start();
		}
		*/
		
		/*	
		public function start(player_id:int):void
		{
			trace("starting...");
			

			
			_player = w.createPerson(player_id,true);
			_player.loadDefault();
			//_player.loadFromServer("assets/player_config.txt");
			FlxG.pause = false;
			


			//rooms = new FlxGroup;
			//rooms.add(_room);
			//add(rooms);
			
			//_room.collide(_player);
		}
		*/
		
		/*
		public function sendPlayerStatus(e:TimerEvent):void
		{
			if (server.ready && _player != null)
			{
				trace("sending status...");
				server.send( "UPDATE " + _player.serialize() );
			}
		}
		
		public function onServerEvent(e:DataEvent):void
		{
			if (e.type == Server.CONNECTED_TO_SERVER)
			{
				server.send("hola!");
			}
			
			if (e.type == Server.SERVER_MSG)
			{
				//first msg
				if (_player == null)
				{
					var a:Array = e.data.split(' ');
					if (a[0] == 'ID')
						start(a[1]);
				}
				else
				{
					if (e.data == '')
					{
						trace("disconnected");
						return;
					}
					
					var a:Array = e.data.split(' ');
					var id:int = a[0];
					if (a[1] == 'BYE')
						deletePerson(a[0]);
					else if (a[1] == 'UPDATE')
					{
						var p:Person = Person.getPerson(id);
						if (p == null)
							createPerson(id,false,e.data);
						else
							updatePerson(id,e.data);
					}
					else
						trace("UNKNOWN: " + e.data);
				}
			}
		}
		*/
				
		
	}
}